%global forgeurl  https://gitlab.freedesktop.org/monado/monado
%global commit    a041c6168332e80cf79698319ab4da533c8eb606
%global date      20250418
%forgemeta


Name:           monado
Version:        25.0.0
Release:        %autorelease
Summary:        The open source OpenXR runtime

License:        GPL-3.0-or-later AND Apache-2.0 AND BSD-2-Clause AND BSD-3-Clause AND BSL-1.0 AND CECILL-C AND CC0-1.0 AND CC-BY-4.0 AND MIT-Khronos-old AND Unlicense AND Zlib AND GPL-2.0-or-later AND MIT AND OFL-1.1
# CECILL-C
# src/external/imgui/imgui/imconfig.h
# CC0-1.0 AND Apache-2.0
# src/external/glad/*
# Unlicense
# src/external/imgui/imgui/backends/imgui_impl_opengl3_loader.h
# Apache-2.0
# gradle*
# src/external/{flexkalman,glad,mermaid,nvpro_pyramid,openxr_includes}/*
# src/xrt/auxiliary/math/m_quatexpmap.cpp
# Apache-2.0 OR MIT
# doc/doxygen-awesome-css/doxygen-awesome-*
# BSD-2-Clause
# cmake/FindEigen3.cmake
# src/external/hungarian/*
# src/external/tracy/{client,common}/*
# cmake/{FindEGL.cmake,FindSystemd.cmake,OptionWithDeps.cmake}
# src/external/openvr_includes/*
# src/external/tinyceres/*
# src/external/tracy/libbacktrace/*
# src/xrt/drivers/north_star/distortion_3d/*
# src/xrt/tracking/hand/mercury/kine_lm/lm_rotations_ceres.inl
# BSD-3-Clause AND BSL-1.0
# src/xrt/targets/steamvr_drv/*
# BSL-1.0
# {CMakeLists.txt,CompilerFlags.cmake,build.gradel}
# cmake/{CleanDirectoryList.cmake,FindHIDAPI.cmake,FindLeapV2.cmake,FindLibcheck.cmake,FindLibusb1.cmake,FindONNXRuntime.cmake,FindOpenGLES.cmake,FindOpenHMD.cmake,FindPercetto.cmake,Findbluetooth.cmake,FindcJSON.cmake,Findudev.cmake,GenerateKhrManifest.cmake,GenerateKhrManifestInternals.cmake.in,GenerateOpenXRRuntimeManifest.cmake,GenerateVulkanApiLayerManifest.cmake,GetGitRevisionDescription.cmake,GetGitRevisionDescription.cmake.in,PrefixListGlob.cmake,ProgramFilesGlob.cmake,SPIR-V.cmake,openxr_manifest.in.json.license}
# src/external/{Catch2,android-jni-wrap,flexkalman,imgui,nvpro_pyramid,openxr_includes,solarxr,util-headers,vit_includes}
# src/xrt/auxiliary/{android,bindings,d3d,gsteamer,math,ogl,os,tracking,util,vive,vk}/*
# src/xrt/compositor/*
# src/xrt/drivers/{android,arduino,daydream,depthai,euroc,hdk,ht,ht_ctrl_emu,hydra,illixr,multi_wrapper,north_star,ohmd,opengloves,psmv,qwerty,realsense,remote,rift_s,rokid,sample,simula,simulated,solarxr,steamvr_lh,survive,twrap,ultraleap_v2,v4l2,vf,vive,wmr,xreal_air}/*
# src/xrt/include/tracking/t_hand_tracking.h
# src/xrt/include/xrt/*
# src/xrt/{ipc,state_trackers,targets,tracking}/*
# tests/*
# BSL-1.0 AND CC0-1.0
# {doc,scripts}/*
# MIT-Khronos-old
# src/external/glad/include/KHR/khrplatform.h
# MIT
# cmake/sanitizers/{FindASan.cmake,FindMSan.cmake,FindSanitizers.cmake,FindTSan.cmake,FindUBSan.cmake,asan-wrapper,sanitize-helpers.cmake}
# doc/doxygen-awesome-css/*
# src/external/{cjson,imgui,jnipp,mermaid,renderdoc_api,solarxr,stb,tracy,valve-file-vdf}/*
# src/xrt/targets/android_common/src/main/res/raw/*
# Zlib
# src/external/nanopb/*


URL:            %{forgeurl}
Source0:        %{forgesource}


BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  glslc
BuildRequires:  ninja-build
BuildRequires:  pkgconfig(bluez)
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(dri)
BuildRequires:  pkgconfig(eigen3)
BuildRequires:  pkgconfig(glslang)
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  pkgconfig(gstreamer-app-1.0)
BuildRequires:  pkgconfig(gstreamer-video-1.0)
BuildRequires:  pkgconfig(hidapi-libusb)
BuildRequires:  pkgconfig(libavcodec)
BuildRequires:  pkgconfig(libbsd)
BuildRequires:  pkgconfig(libcjson)
BuildRequires:  pkgconfig(libdrm)
BuildRequires:  pkgconfig(libjpeg)
# ONNX only for x86_64, ppc64le and aarch64
%ifnarch s390x %{arm} %{ix86}
BuildRequires:  pkgconfig(libonnxruntime)
%endif
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(libusb-1.0)
BuildRequires:  pkgconfig(libuvc)
BuildRequires:  pkgconfig(opencv)
BuildRequires:  pkgconfig(openhmd)
BuildRequires:  pkgconfig(openvr)
BuildRequires:  pkgconfig(openxr)
# Perfetto only supports these architectures
%ifarch aarch64 x86_64
BuildRequires:  pkgconfig(percetto)
%endif
BuildRequires:  pkgconfig(realsense2)
BuildRequires:  pkgconfig(sdl2)
BuildRequires:  pkgconfig(survive)
BuildRequires:  pkgconfig(vulkan)
BuildRequires:  pkgconfig(wayland-client)
BuildRequires:  pkgconfig(wayland-eglstream)
BuildRequires:  pkgconfig(wayland-protocols)
BuildRequires:  pkgconfig(wayland-scanner)
BuildRequires:  pkgconfig(xrandr)
BuildRequires:  pkgconfig(zlib)

# https://bugzilla.redhat.com/show_bug.cgi?id=2279244 - SLAM tracking
#BuildRequires:  pkgconfig(basalt)


%description
Monado is an open-source package for interacting with virtual and
augmented reality (collectively known as XR) hardware and software.

This package provides a runtime that aims to be a complete and conforming
implementation of the OpenXR API from Khronos. When used with the
"simulated" device driver, this package is conforming to OpenXR 1.0.


%package devel
Requires: %{name}%{?_isa} = %{version}-%{release}
Summary:  Development files for Monado

%description devel
Devel information for Monado.


%prep
%forgeautosetup -p1


%build
%cmake \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DDRIVER_HANDTRACKING:BOOL=ON \

%cmake_build


%install
%cmake_install


install -m 0755 -vd %{buildroot}%{_sysconfdir}/xdg/openxr/1/
ln -rs %{buildroot}%{_datarootdir}/openxr/1/openxr_monado.json \
       %{buildroot}%{_sysconfdir}/xdg/openxr/1/active_runtime.json


%files
%license LICENSE LICENSES/*
%doc CONTRIBUTING.md README.md doc/*.md
%caps(cap_sys_nice=eip) %{_bindir}/monado-service
%{_bindir}/monado-cli
%{_bindir}/monado-ctl
%{_bindir}/monado-gui
%{_libdir}/libmonado.so.25
%{_libdir}/libmonado.so.25.0.0
%{_libdir}/libopenxr_monado.so
%{_sysconfdir}/xdg/openxr/1/active_runtime.json
%{_userunitdir}/monado.service
%{_userunitdir}/monado.socket
%{_datarootdir}/openxr/1/openxr_monado.json
%{_datarootdir}/steamvr-monado/*


%files devel
%{_libdir}/libmonado.so
%{_includedir}/monado/monado.h


%changelog
%autochangelog
